//+------------------------------------------------------------------+
//|                                                     training.mq4 |
//|                                      Copyright  2011, Ron Kirby |
//|                                            http://www.blsmur.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Ron Kirby"
#property link      "http://www.blsmur.com"
/* 

     A simple EA with fixed TP SL and Lots 
     Can work on 4 and 5 digit brokers
     Constantly in the market 
     One trade at a time  Signal is fast EMS > Slow EMA  or vice versa
     Option to not trade on Friday 
*/

// include files

// external variables
//extern bool exTrendYesNo        ; // leave on true always
extern int exTakeProfit          = 500;
extern int exStopLoss            = 35;
extern int exTimeFrame           = 0;
extern int exTrailingStop        = 80;
extern double exLots             = 0.01;
extern bool exTradeFriday        = false;
 
extern int exMagic               = 2316;
extern int exSlippage            = 3;
extern int exBreakEven           = 60;
extern int exBEoffset            = 10;
extern int exStopJump            = 5;
extern int zfactor               = 10; 
double TPp, SLp;
 // internal variables(Global Scope)
double  gdPoint;
int x,y;
extern int exTrendYesNo          = 1; 


extern double     FibHigh2       = 0.75;
extern double     FibHigh        = 0.47;
extern double     FibMed        = 0.38;
extern double     FibLow         = 0.25;

int BarCount;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

 gdPoint = Point;
 
 // check if we are on a 5 digit broker
 if(Digits==3||Digits==5){
   gdPoint = gdPoint*10;
   exSlippage =exSlippage*10;
   
   }
   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  if (exTrendYesNo ==1){int   x = 7;  int  y = 5; 
}else{  x = 7 ;   y = 5;
     }
  
        
          
          
          
//----

       // get a count of our open buy and sell OrderSelect
  
  
  int iOrderCnt = CountOrders();
  
  
   
  int iToday = DayOfWeek(); // assign day of week variable


       // if we have no orders we should open one
     if(iOrderCnt == 0 && (iToday!=5 || exTradeFriday)){
      //retnotrend
   // Print ("exTrendYesNo=",exTrendYesNo);
     //Print ("iSignal3=",iSignal3);
  //if (iSignal3 ==2){exTrendYesNo=1;
   
   
  int iSignal1 = CheckSignal(); //iRetVal
  int iSignal2 = CheckTrend(); //irettrend
  int iSignal3 = CheckNonTrend(); //iRetNOTrend
 
 //i  iSignal = iSignal1 || iSignal2 || iSignal3 ;
 
 int iSignal = (iSignal1 + iSignal2) ;
  int iSignal5 = iSignal3;
 int iSignal4 = iSignal3;
 //if (iSignal4 == 7) iSignal= 7;
 //if (iSignal5 == 5) iSignal= 5;
 // Print ("iSignal=",iSignal);
//  Comment ("iSignal3=",iSignal3);
  //Print ("signal=", iSignal );
  if (iSignal == x){
  
  OpenMarketOrder(OP_BUY);
  
  }else if (iSignal == y){
  OpenMarketOrder(OP_SELL);    
         
         }//else Print ("no trade");
       
        
}


     // manage open trade
     
  if (iOrderCnt > 0){
 
    CheckStopLoss ();
    CheckBreakEven();
    CheckTrailingStop();
      CheckExit();
      
      
     } 
    else  { Sleep (360);
   // Print ( "Sleep1 hour" );
        }
//---- 
   return(1);
 
  }

//+------------------------------------------------------------------+


int CountOrders(){
   int iCnt;
   
   for(int i=0;i<OrdersTotal();i++){
   
   if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
   if(OrderSymbol() ==Symbol() && OrderMagicNumber()==exMagic){
    if(OrderType() == OP_BUY || OrderType() == OP_SELL){
      iCnt++;
     
    //Print("Order failed with error#", GetLastError());
      }
   }
 }
 
 return(iCnt);
 }
 // this is the code that geneates a signal to trade or not 
 int CheckTrend(){
     int iRetTrend = 0;
     double dTFastEMA = iMA(NULL,240,14,0,MODE_EMA,PRICE_MEDIAN,0);//yellow
    double dTSlowEMA = iMA(NULL,240,24,0,MODE_EMA,PRICE_MEDIAN,0);  //brown
    double LongTermFastEMA = iMA(NULL,1440,35,0,MODE_EMA,PRICE_MEDIAN,0);
    double LongTermSlowEMA = iMA(NULL,1440,55,0,MODE_EMA,PRICE_MEDIAN,0);
    
    // double dT4EMA = iMA(NULL,exTimeFrame,5,0,MODE_EMA,PRICE_MEDIAN,0);  //brown
    // if(dTFastEMA > dTSlowEMA && dT4EMA < dTFastEMA && dT4EMA > dTSlowEMA  )iRetTrend = 4; 
    // if(dTFastEMA > dTSlowEMA && dT4EMA < dTFastEMA && dT4EMA < dTSlowEMA  )iRetTrend = 3; 
      //yellow above
    // if(dTFastEMA < dTSlowEMA && dT4EMA > dTFastEMA && dT4EMA < dTSlowEMA)iRetTrend = 3; 
     //if(dTFastEMA < dTSlowEMA && dT4EMA > dTFastEMA && dT4EMA > dTSlowEMA)iRetTrend = 4; 
      // brown below
  
  if (dTFastEMA > dTSlowEMA  ) iRetTrend = 4;
  if (dTFastEMA < dTSlowEMA ) iRetTrend = 3;
  
   Print ("iRetTrend=",iRetTrend);
    //Print("Order failed with error#", GetLastError());
     return(iRetTrend);
     
 }
 // this is the code that generates  TREND reversal signals to trade  
 int CheckNonTrend(){
     int iRetNOTrend = 0;
    double dNFastEMA = iMA(NULL,exTimeFrame,5,0,MODE_EMA,PRICE_MEDIAN,0);//purple
    double dNSlowEMA = iMA(NULL,exTimeFrame,55,0,MODE_EMA,PRICE_MEDIAN,0); // pink
    double fibot = iLow(NULL,PERIOD_W1,1);
    double fitop = iHigh(NULL,PERIOD_W1,0);
   // check for swing sell
  // if(dNFastEMA < dNSlowEMA && dNFastEMA < fibot+FibLow && dNFastEMA > fibot)iRetNOTrend = 7; 
       //check for swing buy                                                           //trend is  changed
   //  if(dNFastEMA > dNSlowEMA && dNFastEMA > fitop-FibHigh2 && dNFastEMA < fitop )iRetNOTrend = 5; // no trend do not trade  
    //Comment  ("fibot=",fibot);
   // Print ("iRetNOTrend=",iRetNOTrend);
   //  Print ("fibot*FibLow=",fibot+FibLow);
     //if (MA_1_t > MA_2_t + Rastvor*Point)
     //Print("Order failed with error#", GetLastError());
    return(iRetNOTrend);
    
 }
 // this is the code that geneates a signal to trade or not 
 int CheckSignal(){
     int iRetVal = 0;
     double Fib1_1 = iHigh(NULL,PERIOD_W1,1);
     Print ("last-high-W1",Fib1_1);
     double FibHiLast = iHigh(NULL,PERIOD_H4,1);
     Print ("last-high-H4",FibHiLast);
     double Fib1_2 = iLow(NULL,PERIOD_W1,1);
     Print ("last-LOW-W1",Fib1_2);
     double FibLast = iLow (NULL,PERIOD_H4,1);
     Print ("last-LOW-H4",FibLast);
     if (Fib1_2 > FibLast )Fib1_2 = FibLast ;
     if (Fib1_1 < FibHiLast )Fib1_1 = FibHiLast ;
//Print ("FibLOW-Last",FibLast);
//Print ("fib2=",Fib1_2);
//Print ("FibHiLast",FibHiLast);
//Print ("fib1=",Fib1_1);
 double LtFastEMA = iMA(NULL,exTimeFrame,34,0,MODE_EMA,PRICE_MEDIAN,0);//purple    
  double LtSlowEMA = iMA(NULL,exTimeFrame,55,0,MODE_EMA,PRICE_MEDIAN,0);//purple    
     double FibSell = (((Fib1_1-Fib1_2)*(FibHigh))+Fib1_2);//FibHigh is the 50% fib set by us
     double FibBuy  = (((Fib1_1-Fib1_2)*(FibHigh))-Fib1_1);// modify to +
     double FibSell2 = (((Fib1_1-Fib1_2)*(FibLow))+Fib1_2);
     double FibBuy2  = (((Fib1_1-Fib1_2)*(FibLow))-Fib1_1);
    double buyone = Ask; Print ("ask=",buyone);
   // double difference = FibBuy+0.001;Print ("difference=",difference);
    double sellone = Bid; Print("bid=",sellone);
     double SellPoint = FibSell;
     double BuyPoint = FibBuy;
     
   //if (Buy1_1 < Buy1_2) Order = SIGNAL_BUY;
   if (buyone < FibBuy ) iRetVal = 3;
   
   // if (dTFastEMA > dTSlowEMA  ) iRetTrend = 4;
  
   //Print ("FibBuy=",FibBuy);
   //if (Sell1_1 > Sell1_2) Order = SIGNAL_SELL;
   //if (FibSell < sellone  && FibBuy > sellone && LtFastEMA < LtSlowEMA ) iRetVal = 2;
   //Print ("fibsell=",FibSell);
  
   
    
     Comment ( "buyone= ",buyone,"  iRetVal= ",iRetVal,"      fibsell= ",FibSell,"   FibBuy= ",FibBuy,"   fib1high= ",Fib1_1,"   fib2low= ",Fib1_2);
     //Print("Order failed with error#", GetLastError());
     return(iRetVal);
 }
    
  int CheckExit(){
  
  int iCheckExit = 0;
     double dNFastEMA = iMA(NULL,exTimeFrame,10,0,MODE_EMA,PRICE_MEDIAN,0);//purple
     double dNSlowEMA = iMA(NULL,exTimeFrame,34,0,MODE_EMA,PRICE_MEDIAN,0); // pink
    if(dNFastEMA > dNSlowEMA+ zfactor*gdPoint)iCheckExit = 2; 
                                                                  //trend is un changed
     if(dNFastEMA < dNSlowEMA)iCheckExit = 6; // no trand do not trade  
    // Print ("iCheckExit=",iCheckExit);
  return(iCheckExit);
  }
  
  
  
    
void OpenMarketOrder(int iType){
   
   
   double dOpenPrice;
   string sComment;
   color  cOrderClr;
   
   switch(iType){
   
      case OP_BUY:
           
         
          dOpenPrice = Ask;
          sComment = StringConcatenate(exMagic,"BUY");
          cOrderClr = DodgerBlue;
          break;  
          
       case OP_SELL:
          
          
          dOpenPrice = Bid;
          sComment = StringConcatenate(exMagic,"SELL");
          cOrderClr = Red;  
          break;
          default:
          break;
 }            
  
 Wait(); // make sure we are connected trading is allowed and our trade contextr is not 
 
 // everything is ok to send Order
 //OrderSend( string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment=NULL, int magic=0, datetime expiration=0, color arrow_color=CLR_NONE 
 int iTicket = OrderSend(Symbol(),iType,exLots,dOpenPrice,
            exSlippage,0,0,sComment,exMagic,0,cOrderClr);
            
  // check order was placed correctly
  if (iTicket < 0){
  Print("Order failed with error#", GetLastError());
  }
  
  return(0);
  }
            
 void Wait() {
      if (IsConnected()  &&IsTradeAllowed()) while (IsTradeContextBusy()) Sleep(75);
 
 
 }
 /// function set stoploss
 
 
void CheckStopLoss()
   {
   int result,err;
   string Message;
   
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
         {
         //--------------Modify Take Profit & Stop Loss--------------------------------
         if(OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderTakeProfit()==0 && OrderMagicNumber()==exMagic)
            {
            Print("BUY: Modify order for TP & SL");
            TPp = OrderOpenPrice()+(exTakeProfit*gdPoint);
            SLp = OrderOpenPrice()-(exStopLoss*gdPoint);
            result = OrderModify(OrderTicket(),OrderOpenPrice(),SLp,TPp,0);
            }
          if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderTakeProfit()==0 && OrderMagicNumber()==exMagic)                     
            {
            Print("SELL: Modify order for TP & SL");
            TPp = OrderOpenPrice()-(exTakeProfit*gdPoint);
            SLp = OrderOpenPrice()+(exStopLoss*gdPoint);
            result = OrderModify(OrderTicket(),OrderOpenPrice(),SLp,TPp,0);
            }
         }
                    
      //---------------Check for errors--------------------------
      if (result<0)
         {
         err=GetLastError();
         Message = "Setting of SL "+OrderSymbol()+" ticket no "+OrderTicket()+" failed with error ("+err+")";
         Print(Message);
         Sleep(10000);
         }
      }
   }
//function check for exit

         // trend change close all positions
        
         
         
// func check  for Break Even
 
//adjust SL to  BE + exBEoffset 
 
void CheckBreakEven()
   {
   int result,err;
   string Message;
   
   if(exBreakEven>0)
      {
      for(int i=0;i<OrdersTotal();i++ )
         {
         result=0;
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
            {
            RefreshRates();
            if (OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderStopLoss()<OrderOpenPrice() && OrderMagicNumber()==exMagic)
               {
               if (Bid>OrderOpenPrice()+(exBreakEven*gdPoint))
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(exBEoffset*gdPoint),OrderTakeProfit(),0,CLR_NONE);
                  Print("BUY: BE Set");
                  }
               }
            if (OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderStopLoss()>OrderOpenPrice() && OrderMagicNumber()==exMagic)
               {
               if (Ask<OrderOpenPrice()-(exBreakEven*gdPoint))
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(exBEoffset*gdPoint),OrderTakeProfit(),0,CLR_NONE);
                  Print("SELL: BE Set");
                  }
               }
               
            //---------------Check for errors--------------------------
            if (result<0)
               {
               err=GetLastError();
               Message = "Setting of BE "+OrderSymbol()+" ticket no "+OrderTicket()+" failed with error ("+err+")";
               Print(Message);
               Sleep(10000);
               }            
            }
         }
      }
   }
   
/*{

 double newBE = ((5*gdPoint)+OrderOpenPrice());
 double newBE2 = (OrderOpenPrice()-(5*gdPoint));
for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
      if(OrderMagicNumber()!=exMagic || OrderSymbol()!=Symbol()) continue;
   
      if(OrderType() == OP_BUY)
         {
         //if(((Bid - OrderOpenPrice()) > (pointvalue * TrailingStop)) && (OrderStopLoss() < (Bid - pointvalue * TrailingStop)))
         if((Bid-OrderOpenPrice()) > (gdPoint*exBreakEven))
            OrderModify(
                        OrderTicket(),
                       OrderOpenPrice(),
                      newBE,
                        OrderTakeProfit(),
                        0,
                        GreenYellow);
         }
      
      if(OrderType() == OP_SELL)
         {
         if((OrderOpenPrice()-Ask) > (gdPoint*exBreakEven))
            OrderModify(
                        OrderTicket(),
                        
                      OrderOpenPrice(),
                      newBE2,
                      OrderTakeProfit(),
                        0,
                        Red);
                       }            
      }
}*/      


//----double      dOpenPriceplusz = (dOpenPrice, +(z));
      
      


void CheckTrailingStop()
   {
   int result,err;
   string Message;
   double stoploss,NextStopLevel;
   
   if(exTrailingStop>exBreakEven) NextStopLevel = exTrailingStop; // This stops the trailing stop from kicking in before breakeven
   if(exTrailingStop<=exBreakEven) NextStopLevel = exBreakEven;   // if you have set Trailing Stop less than breakeven
         
   for(int i=0;i<OrdersTotal();i++)
      {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true )
         {
         RefreshRates();
         if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderStopLoss()<=OrderOpenPrice() && OrderMagicNumber()==exMagic)
            {
            if(Ask<OrderStopLoss()-((NextStopLevel+exStopJump)*gdPoint))
               {  
               stoploss = OrderStopLoss()-(exStopJump*gdPoint);
               OrderModify(OrderTicket(),OrderOpenPrice(),stoploss,OrderTakeProfit(),0,Red);
               }
            }         

         if(OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderStopLoss()>=OrderOpenPrice() && OrderMagicNumber()==exMagic)
            {
            if(Bid > OrderStopLoss()+((NextStopLevel+exStopJump)*gdPoint))
               {  
               stoploss = OrderStopLoss()+(exStopJump*gdPoint);
               OrderModify(OrderTicket(),OrderOpenPrice(),stoploss,OrderTakeProfit(),0,Red);
               }
            }
         }
      }
   }
//{

 
//for(int i=0;i<OrdersTotal();i++)
 //     {
  //    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)        break;
 //     if(OrderMagicNumber()!=exMagic || OrderSymbol()!=Symbol()) continue;
   
 //     if(OrderType() == OP_BUY)
 //        {
 //        if(((Bid - OrderOpenPrice()) > (gdPoint * exTrailingStop))&& (OrderStopLoss() < (Bid - gdPoint * exTrailingStop)))
  //       //if((Bid-OrderOpenPrice()) > (gdPoint*exBreakEven))
 //           OrderModify(
 //                       OrderTicket(),
 //                      OrderOpenPrice(),
 //                     Bid - gdPoint * exTrailingStop,
 //                       OrderTakeProfit(),
//                        0,
 //                       GreenYellow);
 //        }
      
 //     if(OrderType() == OP_SELL)
//         {
//         if((OrderOpenPrice()-Ask) > (gdPoint*exTrailingStop))//&& (OrderStopLoss() < (Bid - gdPoint * exTrailingStop)))
//            OrderModify(
 //                       OrderTicket(),
 //                       
 //                     OrderOpenPrice(),
 //                     Ask - gdPoint * exTrailingStop,
 //                     OrderTakeProfit(),
  //                      0,
 //                       Red);
//                       }            
//      }
//}      
 
 
 
 
 // make z a function
 